/* adv_edit.js
======================================================================
==   Sage++ (Higmmer's Edition)                                     ==
==     Copyright (C) Higmmer.NEeT / Higmmer All Rights Reserved.    ==
==     The original Sage is the work of The Sage Project.           ==
======================================================================
*/


var validator = null, acceptor = null;
var strRes, btnOK, value1, value2;


function init() {
	strRes = $("strRes");
	btnOK = $("winMain").getButton("accept");
	btnOK.disabled = true;
	value1 = $("value1");
	value2 = $("value2");
	
	document.title = window.arguments[0];
	var label = window.arguments[1] || [];
	var value = window.arguments[2] || [];
	var desc = window.arguments[3] || [];
	validator = window.arguments[4];
	acceptor = window.arguments[5];
	
	$("label1").value = label[0];
	value1.value = value[0];
	
	if(label.length > 1 && value.length > 1){
		$("sep1").hidden = $("info2").hidden = false;
		$("label2").value = label[1];
		value2.value = value[1];
	}
	if(desc.length > 0){
		$("sep2").hidden = $("desc").hidden = false;
		$("desc1").value = desc[0];
		if(desc.length > 1){
			$("desc2").hidden = false;
			$("desc2").value = desc[1];
		}
	}
	
	validate();
	
	window.setTimeout(moveWinPos, 0);
}

function moveWinPos() {
	var op = window.opener;
	window.moveTo(op.screenX + (op.outerWidth - window.outerWidth) / 2,
	              op.screenY + (op.outerHeight - window.outerHeight) / 2);
}

function accept() {
	if(typeof acceptor == "function"){
		var result = acceptor(getValue());
		if(result != "OK"){
			window.alert(strRes.getString(result));
			return false;
		}
	}
	return true;
}

function validate() {
	if(typeof validator == "function"){
		btnOK.disabled = !validator(getValue());
	}
}

function getValue() {
	return {
		_1: value1 ? value1.value : undefined,
		_2: value2 ? value2.value : undefined
	};
}


/* End of File */
